namespace MainNamespace.Structure
{
    class GraphNode<T>
    {
        private List<GraphNode<T>>? _neighbors;
        private List<int>? _weights;

        public T? Data { get; set; }

        public GraphNode()
        {

        }

        public GraphNode(T data)
        {
            this.Data = data;
        }

        public List<GraphNode<T>> Neighbors
        {
            get
            {
                _neighbors = _neighbors ?? new List<GraphNode<T>>();

                return _neighbors;
            }
        }

        public List<int> Weights
        {
            get
            {
                _weights = _weights ?? new List<int>();

                return _weights;
            }
        }
    }
}